戻り値の型によって処理を変える

# 目的

* 型クラスとは

# 対象者

* プログラマ

# 内容

戻り値の型によって処理を変える

戻り値の型は明確なコンテキスト

引数 Int
戻り値 Int または String
な関数goroを作る

Intの場合

goro 1 -- => 56
goro 2 -- => 5656

Stringの場合

goro 1 -- => "ごろ"
goro 2 -- => "ごろごろ

Haskellでの実装

型クラスをつかえば可能

できない場合、引数で戻り値の型を指定
つまり、戻り値の型で処理が分岐できるというのは、引数がひとつ減らせる

perl スカラコンテキストとリストコンテキスト
http://d.hatena.ne.jp/perlcodesample/20080610/1213199380


オブジェクト指向はレシーバに応じて処理を返ることができる

オブジェクト指向は

x.goro(1)
goro(x, 1)

第1引数の型によって処理を変えることができる

goroInt(x 1)
goroString(x 1)

これに戻り値の型を引数に増やす

goroInt(x, 1, returnType)

要するに型クラスはどこの引数型によってでも処理を変えることができる

組 2の3乗 (IntとStringの3つの組)

Int Int Int
Int Int String
Int String Int
Int String String
String Int Int
String Int String
String String Int
String String String

要するに、引数の最初の型で分岐ができた
最初の引数の型でグルーピングできた

関連する型の組でグルーピングできるようになる

ちなみに、
scalaだと implicit parameterで実現可能

def goro(num, clazz)
  case clazz.new    # 雑な実装
  when String
    "ごろ" * num
  when Numeric
     ("56"* num).to_i   # 雑な実装
  end
end

class String
  def repeat(num)
    self * num
  end
end

class Numeric
  def repeat(num)
    (self.to_s * num).to_i
  end
end

def repeat(target, num)
  case target
  when String
    repeatString(target, num)
  when Numeric
    repeatNumeric(target, num)
  end
end

def repeatString(targen, num)
  target * num
end

def repeatNumeric(targen, num)
  (target.to_s * num).to_i    # Stringも同じでいいじゃんというつっこみはなしで
end
